﻿//
// Copyright (c) 2009-2015, MindFusion LLC - Bulgaria.
//
using System;
using System.Collections.Generic;
using System.Web.UI.WebControls;
using MindFusion.Scheduling;
using MindFusion.Scheduling.WebForms;

namespace MindFusion.Scheduling.Samples.CS.DualView
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                // Set the calendar's date
                DateTime now = DateTime.Today;
                _calendar.Date = new DateTime(now.Year, now.Month, 1);

                // Select the current date
                _calendar.Selection.Add(DateTime.Today);
                _schedule.TimetableSettings.Dates.Clear();
                _schedule.TimetableSettings.Dates.Add(new TimetableDate(DateTime.Today));

                Appointment app = new Appointment();
                app.StartTime = DateTime.Today.AddHours(10);
                app.EndTime = DateTime.Today.AddHours(14);
                app.HeaderText = "test item";
                _schedule.Schedule.Items.Add(app);
            }
            if (IsPostBack)
            {
                //Set the date in the Timetable to match calendar's selection
                DateTime date = _calendar.Selection.Ranges[0];
                _schedule.TimetableSettings.Dates.Clear();
                _schedule.TimetableSettings.Dates.Add(new TimetableDate(date));
            }

            _calendar.Schedule = _schedule.Schedule;
            //Populate the list box with appointments from the Schedule
            lbItems.Items.Clear();
            for (int i = 0; i < _schedule.Schedule.Items.Count; i++)
            {
                lbItems.Items.Add(_schedule.Schedule.Items[i].StartTime.Date.ToString("yyyy/MM/dd") +
                    " " + _schedule.Schedule.Items[i].HeaderText);
            }
            SortListBox();
        }

        //Sort the listbox alphabetically
        private void SortListBox()
        {
            List<ListItem> t = new List<ListItem>();
            Comparison<ListItem> compare = new Comparison<ListItem>(CompareListItems);
            foreach (ListItem lbItem in lbItems.Items)
                t.Add(lbItem);

            t.Sort(compare);
            lbItems.Items.Clear();
            lbItems.Items.AddRange(t.ToArray());

        }

        private int CompareListItems(ListItem li1, ListItem li2)
        {
            return String.Compare(li1.Text, li2.Text);
        }

        //Handles the onVisibleDateChanged event to display selection for the selected month
        protected void _calendar_VisibleDateChanged(object sender, DateChangedEventArgs e)
        {
            _calendar.Selection.Reset();
            _calendar.Selection.Set(e.NewDate);
        }

    }
}